package clientapp;

import java.util.Calendar;
import java.util.Date;

import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.resource.JFaceResources;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Link;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.part.ViewPart;

import communicator.RMIServiceProvider;

import ca.stfx.logic.cwf.engine.DateUtil;
import ca.stfx.logic.cwf.engine.base.entity.WfInstance;
import ca.stfx.logic.cwf.engine.service.IWorkflowEngineService;
import ca.stfx.logic.cwf.mc.base.Util;

public class WfInstanceView extends ViewPart {

	public static final String ID = "clientapp.WfInstanceView";
	public static int instanceNumber = 0;
	private Text txtName;
	private Text txtComment;
	
	
	public void createPartControl(final Composite parent) {
		Composite top = new Composite(parent, SWT.NONE);
		GridLayout layout = new GridLayout();
		layout.marginHeight = 0;
		layout.marginWidth = 0;
		top.setLayout(layout);
		// top banner
		Composite banner = new Composite(top, SWT.NONE);
		banner.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_FILL, GridData.VERTICAL_ALIGN_BEGINNING, true, false));
		layout = new GridLayout();
		layout.marginHeight = 5;
		layout.marginWidth = 10;
		layout.numColumns = 1;
		banner.setLayout(layout);
		
		// setup bold font
		Font boldFont = JFaceResources.getFontRegistry().getBold(JFaceResources.DEFAULT_FONT);    
		
		Label l = new Label(banner, SWT.WRAP);
		l.setText("Create a new workflow Instance! \nAfter creating a new workflow instance you will be able to \nexecute the tasks of the workflow.");
		l.setFont(boldFont);
		
		Calendar theCal = Calendar.getInstance();
		String dateStr = "Date: " + theCal.get(Calendar.DATE) + "/" + theCal.get(Calendar.MONTH) + "/" + theCal.get(Calendar.YEAR);
		
		l = new Label(banner, SWT.WRAP);
		l.setText(dateStr);
		
		Composite body = new Composite(top, SWT.NONE);
		body.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_FILL, GridData.VERTICAL_ALIGN_BEGINNING, true, false));
		layout = new GridLayout();
		layout.marginHeight = 5;
		layout.marginWidth = 10;
		layout.numColumns = 2;
		body.setLayout(layout);
		
		l = new Label(body, SWT.WRAP);
		l.setText("Your name:");
		txtName = new Text(body, SWT.SINGLE | SWT.WRAP);
		txtName.setText("");
		txtName.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		
		l = new Label(top, SWT.WRAP);
		l.setText("Comment:");
		txtComment = new Text(top, SWT.MULTI | SWT.WRAP);
		txtComment.setText("");
		txtComment.setLayoutData(new GridData(GridData.FILL_BOTH));
		
		Button button = new Button(top, SWT.PUSH);
		button.setText("Create");
		button.addMouseListener(new MouseListener() {
			
			
			public void mouseUp(MouseEvent e) {
				// TODO Auto-generated method stub
				
			}
			
			
			public void mouseDown(MouseEvent e) {
				// send data to server and fetch id
				WfInstance newInstance = new WfInstance();
				Date today = DateUtil.getCurrentDate();
				newInstance.setCreationDate(today);
				newInstance.setCreatedBy(txtName.getText());
				newInstance.setNarrative(txtComment.getText());
				IWorkflowEngineService wfEngineService = RMIServiceProvider.getRMIServiceProvider().getWorkflowEngineService();
				newInstance = wfEngineService.createNewWorkflowInstance(newInstance);
				
				MessageDialog.openInformation(parent.getShell(), "Information", "Workflow Instance "+newInstance.getId()+" created successfully.");
			}
			
			
			public void mouseDoubleClick(MouseEvent e) {
				// TODO Auto-generated method stub
				
			}
		});

	}

	public void setFocus() {
	}
}
