package clientapp.view;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

import javax.swing.text.StyleConstants.ColorConstants;

import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.resource.JFaceResources;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.DateTime;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Link;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.part.ViewPart;

import pc.Overall.service.interfaces.IReceiveReferralService;
import pc.entity.PatientDTO;
import pc.entity.ReferralInfoDTO;

import clientapp.IInstanceSelectionListener;

import ca.stfx.logic.cwf.engine.DateUtil;
import ca.stfx.logic.cwf.engine.base.AbstractTask;
import ca.stfx.logic.cwf.engine.base.entity.InstanceInfo;
import ca.stfx.logic.cwf.engine.base.entity.WfInstance;
import ca.stfx.logic.cwf.engine.service.IWorkflowEngineService;

import communicator.RMIServiceProvider;

public class ReceiveReferralView extends ViewPart implements IInstanceSelectionListener{

	private List<WfInstance> activeInstances;
	public static final String TASK_ID = "Overall_Receive_Referral";
	public static final String TASK_NAME = "Receive_Referral";
	
	public static final String ID = "clientapp.ReceiveReferralView";
	public static int instanceNumber = 0;
	
	private Button button;
	private Combo combo;
	private Shell shell;
	
	private DateTime referralDate;
	private Text txtReferredBy;
	private Combo typeOfReferral;
	private Text txtAddress;
	private Text txtPhone;
	private Combo referredTo;
	
	private Button btnRSContCare;
	private Button btnRSContTeam;
	
	private Text txtPatientName;
	private Text txtHcn;
	private Text txtDateofBirth;
	private Button male;
	private Button female;
	private Text txtMetastuses;
	
	private Text txtPrimaryDiagnosis;
	
	
	private long selectedInstanceId = 0;
	
	public void createPartControl(final Composite parent) {
		this.shell = parent.getShell();
		selectedInstanceId = -1;
		Composite top = new Composite(parent, SWT.NONE);
		GridLayout layout = new GridLayout();
		layout.marginHeight = 0;
		layout.marginWidth = 0;
		top.setLayout(layout);
		// top banner
		Composite banner = new Composite(top, SWT.NONE);
		banner.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_FILL, GridData.VERTICAL_ALIGN_BEGINNING, true, false));
		layout = new GridLayout();
		layout.marginHeight = 5;
		layout.marginWidth = 10;
		layout.numColumns = 1;
		banner.setLayout(layout);
		
		// setup bold font
		Font boldFont = JFaceResources.getFontRegistry().getBold(JFaceResources.DEFAULT_FONT);    
		
		Label l = new Label(banner, SWT.WRAP);
		l.setText("Receive Referral for patient");
		l.setFont(boldFont);
		
		Calendar theCal = Calendar.getInstance();
		String dateStr = "Date: " + theCal.get(Calendar.DATE) + "/" + theCal.get(Calendar.MONTH) + "/" + theCal.get(Calendar.YEAR);
		
		l = new Label(banner, SWT.WRAP);
		l.setText(dateStr);
		
			
		Composite banner2 = new Composite(top, SWT.NONE);
		banner2.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_FILL, GridData.VERTICAL_ALIGN_BEGINNING, true, false));
		layout = new GridLayout();
		layout.marginHeight = 5;
		layout.marginWidth = 10;
		layout.numColumns = 2;
		banner2.setLayout(layout);
		
		populateActiveInstances();
		
		l = new Label(banner2, SWT.WRAP);
		l.setText("Active Instance:");
		combo = new Combo(banner2, SWT.DROP_DOWN | SWT.BORDER | SWT.READ_ONLY);
		for(WfInstance instance : activeInstances)
		{
			combo.add("Instance #" + instance.getId());
		}
		
	    combo.addSelectionListener(new SelectionListener() {
			
			public void widgetSelected(SelectionEvent e) {
				if(e == null)
					return;			
				WfInstance selectedInstance = getInstanceByText(((Combo) e.getSource()).getText());
				processSelection(selectedInstance.getId());
			}
			
			public void widgetDefaultSelected(SelectionEvent e) {
				// TODO Auto-generated method stub
				
			}
		});
	    
	    
	    Composite body = new Composite(top, SWT.NONE);
		body.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_FILL, GridData.VERTICAL_ALIGN_BEGINNING, true, false));
		layout = new GridLayout();
		layout.marginHeight = 5;
		layout.marginWidth = 10;
		layout.numColumns = 2;
		body.setLayout(layout);
		
		Composite body1 = new Composite(body, SWT.NONE);
		body1.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_FILL, GridData.VERTICAL_ALIGN_BEGINNING, true, false));
		layout = new GridLayout();
		layout.marginHeight = 5;
		layout.marginWidth = 40;
		layout.numColumns = 2;
		body1.setLayout(layout);
		
		
		Composite body2 = new Composite(body, SWT.NONE);
		body2.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_FILL, GridData.VERTICAL_ALIGN_BEGINNING, true, false));
		layout = new GridLayout();
		layout.marginHeight = 5;
		layout.marginWidth = 10;
		layout.numColumns = 2;
		body2.setLayout(layout);
		
		
		
		
		l = new Label(body1, SWT.WRAP);
		l.setText("Referral Date:");
		l.setLocation(0,0);
		referralDate = new DateTime(body1, SWT.CALENDAR);

		
		
		l = new Label(body1, SWT.WRAP);
		l.setText("Referred By:");
		txtReferredBy = new Text(body1, SWT.SINGLE | SWT.WRAP);
		txtReferredBy.setText("");
		txtReferredBy.setLayoutData(new GridData(250,20));
		txtReferredBy.setBackground(parent.getDisplay().getSystemColor(SWT.COLOR_CYAN));
		

		l = new Label(body1, SWT.WRAP);
		l.setText("Referral Source:");
		btnRSContCare = new Button(body1, SWT.CHECK);
	    btnRSContCare.setText("CONTINUING CARE");
	    
	    l = new Label(body1,SWT.WRAP);
		l.setText("");
		btnRSContTeam = new Button(body1, SWT.CHECK);
	    btnRSContTeam.setText("CONSULT TEAM");
	    
		
		l = new Label(body1, SWT.WRAP);
		l.setText("Type of Referral:");
		typeOfReferral = new Combo(body1, SWT.DROP_DOWN | SWT.BORDER | SWT.READ_ONLY);
		typeOfReferral.add("STAT");
		typeOfReferral.add("URGENT");
		typeOfReferral.add("ELECTIVE");
		typeOfReferral.setText("STAT");
		
		l = new Label(body1, SWT.WRAP);
		l.setText("Address:");
		txtAddress = new Text(body1, SWT.MULTI | SWT.WRAP);
		txtAddress.setText("");
		txtAddress.setLayoutData(new GridData(250,60));
		
		
		l = new Label(body1, SWT.WRAP);
		l.setText("Telephone:");
		txtPhone = new Text(body1, SWT.SINGLE | SWT.WRAP);
		txtPhone.setText("");
		txtPhone.setLayoutData(new GridData(80, 20)); //GridData.FILL_HORIZONTAL));
		txtPhone.setBackground(parent.getDisplay().getSystemColor(SWT.COLOR_CYAN));
		
		l = new Label(body1, SWT.WRAP);
		l.setText("Referred To:");
		referredTo = new Combo(body1, SWT.DROP_DOWN | SWT.BORDER | SWT.READ_ONLY);
		referredTo.add("NURSE_CONSULTANT");
		referredTo.add("PHYSICIAN");
		referredTo.setText("PHYSICIAN");
		
		
		l = new Label(body2, SWT.WRAP);
		l.setText("Patient Name:");
		txtPatientName = new Text(body2, SWT.SINGLE | SWT.WRAP);
		txtPatientName.setText("");
		txtPatientName.setLayoutData(new GridData(250, 20));
		txtPatientName.setBackground(parent.getDisplay().getSystemColor(SWT.COLOR_CYAN));
		
		l = new Label(body2, SWT.WRAP);
		l.setText("HCN:");
		txtHcn = new Text(body2, SWT.SINGLE | SWT.WRAP);
		txtHcn.setText("");
		txtHcn.setLayoutData(new GridData(120,20));
		
		l = new Label(body2, SWT.WRAP);
		l.setText("DOB:");
		
		Composite dobspace = new Composite(body2, SWT.NONE);
		dobspace.setLayoutData(new GridData(GridData.BEGINNING, GridData.VERTICAL_ALIGN_BEGINNING, false, false));
		layout = new GridLayout();
		layout.marginHeight = 5;
		layout.marginWidth = 10;
		layout.numColumns = 2;
		dobspace.setLayout(layout);
		
		txtDateofBirth = new Text(dobspace, SWT.SINGLE | SWT.WRAP);
		txtDateofBirth.setText("");
		txtDateofBirth.setLayoutData(new GridData(100, 20)); //GridData.FILL_HORIZONTAL));
		
		
		Image image = clientapp.Activator.getImageDescriptor("/icons/Calendar.jpg").createImage();
		Button open = new Button (dobspace, SWT.PUSH);
		  
		  open.setImage(image);
		  open.addSelectionListener (new SelectionAdapter () {
		    public void widgetSelected (SelectionEvent e) {
		      final Shell dialog = new Shell (shell, SWT.DIALOG_TRIM);
		      dialog.setLayout (new GridLayout (3, false));

		      final DateTime calendar = new DateTime (dialog, SWT.CALENDAR | SWT.BORDER);
		      

		      new Label (dialog, SWT.NONE);
		      new Label (dialog, SWT.NONE);
		      Button ok = new Button (dialog, SWT.PUSH);
		      ok.setText ("OK");
		      ok.setLayoutData(new GridData (SWT.FILL, SWT.CENTER, false, false));
		      ok.addSelectionListener (new SelectionAdapter () {
		        public void widgetSelected (SelectionEvent e) {
		          String theDateStr = calendar.getDay () + "/" + (calendar.getMonth () + 1) + "/" + calendar.getYear ();
		          txtDateofBirth.setText(theDateStr);
		          //System.out.println ("Calendar date selected (MM/DD/YYYY) = " + (calendar.getMonth () + 1) + "/" + calendar.getDay () + "/" + calendar.getYear ());
		          dialog.close ();
		        }
		      });
		      dialog.setDefaultButton (ok);
		      dialog.pack ();
		      dialog.open ();
		    }
		  });
		
		
		l = new Label(body2, SWT.WRAP);
		l.setText("Sex:");
		male = new Button(body2, SWT.RADIO);
	    male.setText("MALE");
		
	    l = new Label(body2, SWT.WRAP);
		l.setText("");
		female = new Button(body2, SWT.RADIO);
	    female.setText("FEMALE");
	    
	    male.addSelectionListener(new SelectionAdapter() {
	        public void widgetSelected(SelectionEvent e) {
	          male.setSelection(true);
	          female.setSelection(false);
	        }
	      });
	    female.addSelectionListener(new SelectionAdapter() {
	        public void widgetSelected(SelectionEvent e) {
	          female.setSelection(true);
	          male.setSelection(false);
	        }
	      });
		
		l = new Label(body2, SWT.WRAP);
		l.setText("Metastuses:");
		txtMetastuses = new Text(body2, SWT.SINGLE | SWT.WRAP);
		txtMetastuses.setText("");
		txtMetastuses.setLayoutData(new GridData(100, 20)); //GridData.FILL_HORIZONTAL));
				
		
		
		Composite bodyLast = new Composite(top, SWT.NONE);
		bodyLast.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_FILL, GridData.VERTICAL_ALIGN_BEGINNING, true, false));
		layout = new GridLayout();
		layout.marginHeight = 5;
		layout.marginWidth = 40;
		layout.numColumns = 1;
		bodyLast.setLayout(layout);
		
		  
		l = new Label(bodyLast, SWT.WRAP);
		l.setText("Primary Diagnosis:");
		txtPrimaryDiagnosis = new Text(bodyLast, SWT.MULTI | SWT.WRAP);
		txtPrimaryDiagnosis.setText("");
		txtPrimaryDiagnosis.setLayoutData(new GridData(500, 70)); //GridData.FILL_HORIZONTAL));

		button = new Button(bodyLast, SWT.PUSH);
		button.setText("ACTION");
		button.setEnabled(false);
		button.addMouseListener(new MouseListener() {			
			public void mouseUp(MouseEvent e) {
			}
			public void mouseDown(MouseEvent e) {
				if(selectedInstanceId ==-1)
				{
					MessageDialog.openError(shell, "Error",  "You have not selected any instance");
					return ;
				}
				
				if( validateField(txtReferredBy, "Referral Name") == false)
					return;
				if( validateField(txtPatientName, "Patient Name") == false)
					return;
				if( validateField(txtPhone, "Phone Number") == false)
					return;
				
				// invoke the server
				ReferralInfoDTO newReferralInfo = new ReferralInfoDTO();
				newReferralInfo.setAddress(txtAddress.getText());
				newReferralInfo.setCreationDate(DateUtil.getCurrentDate());
				newReferralInfo.setDob(DateUtil.getDateFromString(txtDateofBirth.getText()));
				newReferralInfo.setHcn(txtHcn.getText());
				newReferralInfo.setInstanceId(selectedInstanceId);
				newReferralInfo.setMetastuses(txtMetastuses.getText());
				newReferralInfo.setPatientName(txtPatientName.getText());
				newReferralInfo.setPhoneNumber(txtPhone.getText());
				newReferralInfo.setPrimaryDiagnosis(txtPrimaryDiagnosis.getText());
				Date refDate = new Date(referralDate.getYear(), referralDate.getMonth(), referralDate.getDay());
				newReferralInfo.setReferralDate(refDate);
				newReferralInfo.setReferredBy(txtReferredBy.getText());
				newReferralInfo.setReferredTo(referredTo.getText());
				if(btnRSContTeam.getSelection() == true)
					newReferralInfo.setRefFromConsultTeam(new Integer(1));
				if(btnRSContCare.getSelection() == true)
					newReferralInfo.setRefFromContunuingCare(new Integer(1));
				if(male.getSelection() == true)
					newReferralInfo.setSex(PatientDTO.MALE);
				if(female.getSelection() == true)
					newReferralInfo.setSex(PatientDTO.FEMALE);
				
				newReferralInfo.setTypeOfReferral(typeOfReferral.getSelectionIndex());
				
				IReceiveReferralService receiveReferralService = RMIServiceProvider.getRMIServiceProvider().getReceiveReferralService();
				try
				{
					newReferralInfo = receiveReferralService.saveReferralInfo(newReferralInfo);
					MessageDialog.openInformation(parent.getShell(), "Information", "Referral Info " + newReferralInfo.getId() + " created successfully.");
					button.setEnabled(false);
				}
				catch(Exception ex)
				{
					MessageDialog.openError(shell, "Error", ex.getMessage());
				} 
			}
			public void mouseDoubleClick(MouseEvent e) {
			}
		});

	}
	
	
	
	private boolean validateField(Text txtField, String fieldName)
	{
		if(txtField.getText().length() == 0){
			MessageDialog.openError(shell, "Error",  fieldName + " cannot be empty.");
			return false;
		}
		return true;
	}
	
	public void setActiveInstance(Long instanceId)
	{
		combo.setText( "Instance #" + instanceId);
		processSelection(instanceId);
	}
	
	
	private void processSelection(Long instanceId)
	{		
		this.selectedInstanceId = instanceId;
		IWorkflowEngineService wfEngineService = RMIServiceProvider.getRMIServiceProvider().getWorkflowEngineService();
		List<InstanceInfo> infos = wfEngineService.getAvailableMethods(instanceId, TASK_ID);
		button.setEnabled(false);
		
		for(InstanceInfo info : infos)
		{
			if(info.getAvailableMethod().equals(AbstractTask._ACTION)){
				button.setEnabled(true);
				return;
			}
		}
	}
	
	private void populateActiveInstances()
	{
		IWorkflowEngineService wfEngineService = RMIServiceProvider.getRMIServiceProvider().getWorkflowEngineService();
		activeInstances = wfEngineService.getAllActiveInstances();
		if(activeInstances == null)
			activeInstances = new ArrayList<WfInstance>();
	}
	private WfInstance getInstanceByText(String instanceText)
	{
		for(WfInstance ins : activeInstances)
		{
			String name = "Instance #" + ins.getId();
			if(name.equals(instanceText))
				return ins;
		}
		return null;
	}

	public void setFocus() {
	}
}
