package communicator;

import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

import pc.Overall.service.interfaces.IAppointmentService;
import pc.Overall.service.interfaces.IConsultService;
import pc.Overall.service.interfaces.IPatientRegistrationService;
import pc.Overall.service.interfaces.IPhysicianService;
import pc.Overall.service.interfaces.IReceiveReferralService;
import pc.TeamBuilding.service.interfaces.IFamilyPhysicianService;
import pc.TeamBuilding.service.interfaces.IHomeService;
import pc.TeamBuilding.service.interfaces.IInformalCaregiverService;
import pc.TeamBuilding.service.interfaces.IMoveToHospitalService;
import pc.TeamBuilding.service.interfaces.IPcPhysicianService;

import ca.stfx.logic.cwf.engine.service.IWorkflowEngineService;

public class RMIServiceProvider {

	public static RMIServiceProvider singleton = new RMIServiceProvider();

	private ApplicationContext ctx = null;
	private IWorkflowEngineService workflowEngineService;
	private IReceiveReferralService receiveReferralService;
	private IPhysicianService physicianService;
	private IAppointmentService appointmentService;
	private IConsultService consultService;
	private IPatientRegistrationService patientRegistrationService;
	private IHomeService homeService;
	private IMoveToHospitalService moveToHospitalService;
	private IInformalCaregiverService informalCaregiverService;
	private IInformalCaregiverService informalCaregiver2Service;
	private IFamilyPhysicianService familyPhysicianService;
	private IPcPhysicianService pcPhysicianService;
	
	
	private RMIServiceProvider()
	{		
	    // Should put in a parent class that extends TestCase
	    String[] paths = {"clientApplicationContext.xml"};
	    ctx = new ClassPathXmlApplicationContext(paths);
	    setUp();
	}

    protected void setUp() {        
         workflowEngineService = (IWorkflowEngineService) ctx.getBean("CWFEngineService");
         receiveReferralService = (IReceiveReferralService) ctx.getBean("ReceiveReferralService");
         physicianService = (IPhysicianService) ctx.getBean("PhysicianService");
         appointmentService = (IAppointmentService) ctx.getBean("AppointmentService");
         consultService = (IConsultService) ctx.getBean("ConsultService");
         patientRegistrationService = (IPatientRegistrationService) ctx.getBean("PatientRegistrationService");
         homeService = (IHomeService) ctx.getBean("HomeService");
         moveToHospitalService = (IMoveToHospitalService) ctx.getBean("MoveToHospitalService");
         informalCaregiverService = (IInformalCaregiverService) ctx.getBean("InformalCaregiverService");
         informalCaregiver2Service = (IInformalCaregiverService) ctx.getBean("InformalCaregiver2Service");
         familyPhysicianService = (IFamilyPhysicianService) ctx.getBean("FamilyPhysicianService");
         pcPhysicianService = (IPcPhysicianService) ctx.getBean("PCPhysicianService");
    }

	public IWorkflowEngineService getWorkflowEngineService()
	{
		return workflowEngineService;
	}
		
	public IReceiveReferralService getReceiveReferralService()
	{
		return receiveReferralService;
	}
	public IPhysicianService getPhysicianService()
	{
		return physicianService;
	}
	public IAppointmentService getAppointmentService()
	{
		return appointmentService;
	}
	public static RMIServiceProvider getRMIServiceProvider()
	{
		return singleton;
	}

	public IConsultService getConsultService() {
		return consultService;
	}

	public IPatientRegistrationService getPatientRegistrationService() {
		return patientRegistrationService;
	}

	public IHomeService getHomeService() {
		return homeService;
	}

	public IMoveToHospitalService getMoveToHospitalService() {
		return moveToHospitalService;
	}

	public IInformalCaregiverService getInformalCaregiverService() {
		return informalCaregiverService;
	}

	public IInformalCaregiverService getInformalCaregiver2Service() {
		return informalCaregiver2Service;
	}

	public IFamilyPhysicianService getFamilyPhysicianService() {
		return familyPhysicianService;
	}

	public IPcPhysicianService getPcPhysicianService() {
		return pcPhysicianService;
	}
}
