-- phpMyAdmin SQL Dump
-- version 2.11.6
-- http://www.phpmyadmin.net
--
-- Host: localhost
-- Generation Time: Aug 23, 2010 at 07:46 PM
-- Server version: 5.0.51
-- PHP Version: 5.2.6

SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;

--
-- Database: `dbcwf`
--
CREATE DATABASE `dbcwf` DEFAULT CHARACTER SET latin1 COLLATE latin1_swedish_ci;
USE `dbcwf`;

-- --------------------------------------------------------

--
-- Table structure for table `appointment`
--

CREATE TABLE `appointment` (
  `id` bigint(20) NOT NULL auto_increment,
  `instanceId` bigint(20) NOT NULL,
  `title` varchar(255) default NULL,
  `creationDate` date NOT NULL,
  `patientName` varchar(255) NOT NULL,
  `physicianId` bigint(20) NOT NULL,
  `appointmentDate` varchar(255) NOT NULL,
  `appointmentTime` varchar(255) NOT NULL,
  `narrative` varchar(255) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `appointment`
--


-- --------------------------------------------------------

--
-- Table structure for table `homeservice`
--

CREATE TABLE `homeservice` (
  `id` bigint(20) NOT NULL auto_increment,
  `instanceId` bigint(20) default NULL,
  `title` varchar(255) default NULL,
  `creationDate` date default NULL,
  `contactPerson` varchar(255) NOT NULL,
  `address1` varchar(255) default NULL,
  `address2` varchar(255) default NULL,
  `workingArea` varchar(1000) default NULL,
  `phoneNumber` varchar(255) NOT NULL,
  `narrative` varchar(255) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `homeservice`
--


-- --------------------------------------------------------

--
-- Table structure for table `informalcaregiver`
--

CREATE TABLE `informalcaregiver` (
  `id` bigint(20) NOT NULL auto_increment,
  `instanceId` bigint(20) NOT NULL,
  `title` varchar(255) default NULL,
  `creationDate` date default NULL,
  `lastName` varchar(255) NOT NULL,
  `firstName` varchar(255) NOT NULL,
  `address1` varchar(255) default NULL,
  `address2` varchar(255) default NULL,
  `phone` varchar(255) NOT NULL,
  `zip` varchar(255) default NULL,
  `relationship` varchar(255) default NULL,
  `patientId` bigint(20) NOT NULL,
  `narrative` varchar(255) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `informalcaregiver`
--


-- --------------------------------------------------------

--
-- Table structure for table `instanceinfo`
--

CREATE TABLE `instanceinfo` (
  `id` bigint(20) NOT NULL auto_increment,
  `instanceId` bigint(20) NOT NULL,
  `taskId` varchar(255) default NULL,
  `workflowName` varchar(255) default NULL,
  `varName` varchar(255) NOT NULL,
  `Varvalue` int(11) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `instanceinfo`
--


-- --------------------------------------------------------

--
-- Table structure for table `patient`
--

CREATE TABLE `patient` (
  `id` bigint(20) NOT NULL auto_increment,
  `instanceId` bigint(20) NOT NULL,
  `title` varchar(255) default NULL,
  `creationDate` date default NULL,
  `lastName` varchar(255) NOT NULL,
  `firstName` varchar(255) NOT NULL,
  `birthDate` varchar(255) NOT NULL,
  `address1` varchar(255) default NULL,
  `address2` varchar(255) default NULL,
  `zip` varchar(255) default NULL,
  `country` varchar(255) NOT NULL,
  `phoneNumber` varchar(255) NOT NULL,
  `location` int(11) NOT NULL,
  `specialComment` varchar(255) default NULL,
  `homeServiceId` bigint(20) default NULL,
  `hospitalEntryDate` varchar(255) default NULL,
  `receivedBy` varchar(255) default NULL,
  `formalCaregiverId` bigint(20) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `patient`
--


-- --------------------------------------------------------

--
-- Table structure for table `physician`
--

CREATE TABLE `physician` (
  `id` bigint(20) NOT NULL auto_increment,
  `instanceId` bigint(20) default NULL,
  `title` varchar(255) default NULL,
  `creationDate` date default NULL,
  `lastName` varchar(255) NOT NULL,
  `firstName` varchar(255) NOT NULL,
  `designation` varchar(255) NOT NULL,
  `department` varchar(255) default NULL,
  `address1` varchar(255) default NULL,
  `address2` varchar(255) default NULL,
  `birthDate` varchar(255) default NULL,
  `phoneNumber` varchar(255) NOT NULL,
  `zip` varchar(255) default NULL,
  `type` int(11) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `physician`
--


-- --------------------------------------------------------

--
-- Table structure for table `referralinfo`
--

CREATE TABLE `referralinfo` (
  `id` bigint(20) NOT NULL auto_increment,
  `instanceId` bigint(20) NOT NULL,
  `title` varchar(255) default NULL,
  `creationDate` date default NULL,
  `referralDate` date default NULL,
  `referredBy` varchar(255) NOT NULL,
  `typeOfReferral` int(11) default NULL,
  `address` varchar(255) default NULL,
  `phoneNumber` varchar(255) NOT NULL,
  `referredTo` varchar(255) default NULL,
  `refFromContunuingCare` int(11) default NULL,
  `refFromConsultTeam` int(11) default NULL,
  `patientName` varchar(255) NOT NULL,
  `hcn` varchar(255) default NULL,
  `dob` date default NULL,
  `sex` int(11) NOT NULL,
  `metastuses` varchar(255) default NULL,
  `primaryDiagnosis` varchar(255) default NULL,
  `comment` varchar(255) default NULL,
  `admissionDecision` int(11) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `referralinfo`
--


-- --------------------------------------------------------

--
-- Table structure for table `wfinstance`
--

CREATE TABLE `wfinstance` (
  `id` bigint(20) NOT NULL auto_increment,
  `status` int(11) default NULL,
  `narrative` varchar(255) default NULL,
  `workflowName` varchar(255) default NULL,
  `createdBy` varchar(255) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `wfinstance`
--

