package pc.Overall.service;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import ca.stfx.logic.cwf.engine.base.AbstractTask;
import ca.stfx.logic.cwf.engine.base.entity.InstanceInfo;
import ca.stfx.logic.cwf.engine.exception.IlligalOperationException;
import pc.util.Constants;
import ca.stfx.logic.cwf.engine.base.ActionInterface;
import ca.stfx.logic.cwf.engine.base.IBranchCondition;

abstract public class Overall_Patient_Valid extends AbstractTask implements ActionInterface, IBranchCondition{

	public final List<String> getAvailableOperations(long instanceId, Map<String, InstanceInfo> varMap){
		List<String> ops = new ArrayList<String>();

		if ( (varMap.get(Constants._Overall_Consult_SUC) != null && varMap.get(Constants._Overall_Consult_SUC).getValue()  > 0 ) )
				ops.add( _ACTION );
		return ops;
	}
	public void action(long instanceId)throws IlligalOperationException{
		Map<String, InstanceInfo> varMap = workflowEngineService.getVarMap(instanceId);

		if ( (varMap.get(Constants._Overall_Consult_SUC) != null && varMap.get(Constants._Overall_Consult_SUC).getValue()  > 0 ) ){			
			decrValue(varMap, Constants._Overall_Consult_SUC);
		}
		else {			
			return;
		}
		if ( getBranchCondition(instanceId, 1) ){			
			incrValue(varMap, Constants._Overall_Patient_Valid_SUC_0);
			workflowEngineService.updateTaskStatus(instanceId, varMap);
			return;
		}
		if ( getBranchCondition(instanceId, 2) ){			
			incrValue(varMap, Constants._Overall_Patient_Valid_SUC_1);
			workflowEngineService.updateTaskStatus(instanceId, varMap);
			return;
		}
			throw new IlligalOperationException("Error executing workflow. Operation action is not allowed right now.");
	}

	public String getTaskName(){
		return "Overall_Patient_Valid";
	}
}
