package pc.Overall.service;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import ca.stfx.logic.cwf.engine.base.AbstractTask;
import ca.stfx.logic.cwf.engine.base.entity.InstanceInfo;
import ca.stfx.logic.cwf.engine.exception.IlligalOperationException;
import pc.util.Constants;
import ca.stfx.logic.cwf.engine.base.ActionInterface;
import ca.stfx.logic.cwf.engine.base.AbortInterface;
import ca.stfx.logic.cwf.engine.base.FailInterface;
import ca.stfx.logic.cwf.engine.base.CmpActionInterface;
import ca.stfx.logic.cwf.engine.base.CmpAbortInterface;

public class Overall_Team_Building extends AbstractTask implements ActionInterface, AbortInterface, FailInterface, CmpActionInterface, CmpAbortInterface{

	public final List<String> getAvailableOperations(long instanceId, Map<String, InstanceInfo> varMap){
		List<String> ops = new ArrayList<String>();

		if ( (varMap.get(Constants._Overall_Intake_SUC) != null && varMap.get(Constants._Overall_Intake_SUC).getValue()  > 0 ) )
				ops.add( _CMP_ACTION );
		if ( (varMap.get(Constants._Overall_Team_Building_CEnd) != null && varMap.get(Constants._Overall_Team_Building_CEnd).getValue()  > 0 ) )
				ops.add( _ACTION );
		if ( (varMap.get(Constants._Overall_Team_Building_CAbtEnd) != null && varMap.get(Constants._Overall_Team_Building_CAbtEnd).getValue()  > 0 ) )
				ops.add( _ABORT );
		return ops;
	}
	public void action(long instanceId)throws IlligalOperationException{
		Map<String, InstanceInfo> varMap = workflowEngineService.getVarMap(instanceId);

		if ( (varMap.get(Constants._Overall_Team_Building_CEnd) != null && varMap.get(Constants._Overall_Team_Building_CEnd).getValue()  > 0 ) ){			
			decrValue(varMap, Constants._Overall_Team_Building_CEnd);
			incrValue(varMap, Constants._Overall_Team_Building_SUC);
			workflowEngineService.updateTaskStatus(instanceId, varMap);
			return;
		}
			throw new IlligalOperationException("Error executing workflow. Operation action is not allowed right now.");
	}
	public void abort(long instanceId)throws IlligalOperationException{
		Map<String, InstanceInfo> varMap = workflowEngineService.getVarMap(instanceId);

		if ( (varMap.get(Constants._Overall_Team_Building_CAbtEnd) != null && varMap.get(Constants._Overall_Team_Building_CAbtEnd).getValue()  > 0 ) ){			
			decrValue(varMap, Constants._Overall_Team_Building_CAbtEnd);
			incrValue(varMap, Constants._Overall_Team_Building_ABT);
			workflowEngineService.updateTaskStatus(instanceId, varMap);
			return;
		}
			throw new IlligalOperationException("Error executing workflow. Operation abort is not allowed right now.");
	}
	public void fail(long instanceId)throws IlligalOperationException{
		Map<String, InstanceInfo> varMap = workflowEngineService.getVarMap(instanceId);

			throw new IlligalOperationException("Error executing workflow. Operation fail is not allowed right now.");
	}
	public void cmpAction(long instanceId)throws IlligalOperationException{
		Map<String, InstanceInfo> varMap = workflowEngineService.getVarMap(instanceId);

		if ( (varMap.get(Constants._Overall_Intake_SUC) != null && varMap.get(Constants._Overall_Intake_SUC).getValue()  > 0 ) ){			
			decrValue(varMap, Constants._Overall_Intake_SUC);
			incrValue(varMap, Constants._Overall_Team_Building_CStart);
			workflowEngineService.updateTaskStatus(instanceId, varMap);
			return;
		}
			throw new IlligalOperationException("Error executing workflow. Operation cmpAction is not allowed right now.");
	}
	public void cmpAbort(long instanceId)throws IlligalOperationException{
		Map<String, InstanceInfo> varMap = workflowEngineService.getVarMap(instanceId);

			throw new IlligalOperationException("Error executing workflow. Operation cmpAbort is not allowed right now.");
	}

	public String getTaskName(){
		return "Overall_Team_Building";
	}
}
