package pc.Overall.service.impl;

import java.util.List;

import ca.stfx.logic.cwf.engine.base.entity.PersistantCapableDTO;
import ca.stfx.logic.cwf.engine.exception.IlligalOperationException;

import pc.Overall.dao.IAppointmentDao;
import pc.Overall.dao.IReceiveReferralDao;
import pc.Overall.service.Overall_Appointment;
import pc.Overall.service.Overall_Receive_Referral;
import pc.Overall.service.interfaces.IAppointmentService;
import pc.Overall.service.interfaces.IPhysicianService;
import pc.Overall.service.interfaces.IReceiveReferralService;
import pc.entity.AppointmentDTO;
import pc.entity.ReferralInfoDTO;

public class AppointmentServiceImpl extends Overall_Appointment implements IAppointmentService{

	private IAppointmentDao appointmentDao;
	private IPhysicianService physicianService;

	public AppointmentDTO saveAppointment(AppointmentDTO appointmentInfo) throws IlligalOperationException {
		// validate physician
		if( physicianService.findPhysicianInfoById(appointmentInfo.getPhysicianId()) == null)
			throw new IlligalOperationException("Physician id : " + appointmentInfo.getPhysicianId() + " does not exists.");
		
		appointmentDao.saveEntity(appointmentInfo);
		action(appointmentInfo.getInstanceId());
		return appointmentInfo;
	}

	public AppointmentDTO findAppointmentInfoById(Long id) {
		return (AppointmentDTO) appointmentDao.findById(id);
	}

	public AppointmentDTO findAppointmentInfoByInstanceId(Long instanceId) {
		List<PersistantCapableDTO> infoList = appointmentDao.findByInstanceId(instanceId);
		if(infoList == null || infoList.size() == 0)
			return null;
		return (AppointmentDTO) infoList.get(0);
	}
	





	public AppointmentDTO updateAppointmentInfo(AppointmentDTO appointmentInfo) {
		appointmentDao.updateEntity(appointmentInfo);
		return appointmentInfo;
	}
	
	
	public void setAppointmentDao(IAppointmentDao appointmentDao) {
		this.appointmentDao = appointmentDao;
	}
	
	public boolean isManual()
	{
		return true;
	}

	public void setPhysicianService(IPhysicianService physicianService) {
		this.physicianService = physicianService;
	}
}
