package pc.Overall.service.impl;

import java.util.List;

import ca.stfx.logic.cwf.engine.base.entity.PersistantCapableDTO;
import ca.stfx.logic.cwf.engine.exception.IlligalOperationException;

import pc.Overall.dao.IPatientRegistrationDao;
import pc.Overall.service.Overall_Intake;
import pc.Overall.service.interfaces.IPatientRegistrationService;
import pc.entity.PatientDTO;


public class PatientRegistrationServiceImpl extends Overall_Intake implements IPatientRegistrationService{

	private IPatientRegistrationDao patientRegistrationDao;

	

	public PatientDTO findPatientInfoById(Long id) {
		return (PatientDTO) patientRegistrationDao.findById(id);
	}

	public PatientDTO findPatientInfoByInstanceId(Long instanceId) {
		List<PersistantCapableDTO> infoList = patientRegistrationDao.findByInstanceId(instanceId);
		if(infoList == null || infoList.size() == 0)
			return null;
		return (PatientDTO) infoList.get(0);
	}
	

	public PatientDTO savePatientInfo(PatientDTO patientInfo) throws IlligalOperationException {
		patientRegistrationDao.saveEntity(patientInfo);
		action(patientInfo.getInstanceId());
		return patientInfo;
	}



	public PatientDTO updatePatientInfo(PatientDTO patientInfo) {
		patientRegistrationDao.updateEntity(patientInfo);
		return patientInfo;
	}
	
	
	public void setPatientRegistrationDao(IPatientRegistrationDao patientRegistrationDao) {
		this.patientRegistrationDao = patientRegistrationDao;
	}
	
	public boolean isManual()
	{
		return true;
	}
}
