package pc.Overall.service.impl;

import java.util.List;

import ca.stfx.logic.cwf.engine.base.entity.PersistantCapableDTO;
import ca.stfx.logic.cwf.engine.exception.IlligalOperationException;

import pc.Overall.dao.IAppointmentDao;
import pc.Overall.dao.IPhysicianDao;
import pc.Overall.dao.IReceiveReferralDao;
import pc.Overall.service.Overall_Appointment;
import pc.Overall.service.Overall_Receive_Referral;
import pc.Overall.service.interfaces.IAppointmentService;
import pc.Overall.service.interfaces.IPhysicianService;
import pc.Overall.service.interfaces.IReceiveReferralService;
import pc.entity.AppointmentDTO;
import pc.entity.PhysicianDTO;
import pc.entity.ReferralInfoDTO;

public class PhysicianServiceImpl  implements IPhysicianService{

	private IPhysicianDao physicianDao;

	

	public PhysicianDTO findPhysicianInfoById(Long id) {
		return (PhysicianDTO) physicianDao.findById(id);
	}

	public PhysicianDTO findPhysicianInfoByInstanceId(Long instanceId) {
		List<PersistantCapableDTO> infoList = physicianDao.findByInstanceId(instanceId);
		if(infoList == null || infoList.size() == 0)
			return null;
		return (PhysicianDTO) infoList.get(0);
	}
	

	public PhysicianDTO savePhysician(PhysicianDTO physicianInfo) throws IlligalOperationException {
		physicianDao.saveEntity(physicianInfo);		
		return physicianInfo;
	}



	public PhysicianDTO updatePhysicianInfo(PhysicianDTO physicianInfo) {
		physicianDao.updateEntity(physicianInfo);
		return physicianInfo;
	}
	
	
	public void setPhysicianDao(IPhysicianDao physicianDao) {
		this.physicianDao = physicianDao;
	}

	public List<PersistantCapableDTO> findAllPhysician() {
		return  physicianDao.findAllEntity();		
	}
		
}
