package pc.Overall.service.impl;

import java.util.List;

import ca.stfx.logic.cwf.engine.base.entity.PersistantCapableDTO;
import ca.stfx.logic.cwf.engine.exception.IlligalOperationException;

import pc.Overall.dao.IReceiveReferralDao;
import pc.Overall.service.Overall_Receive_Referral;
import pc.Overall.service.interfaces.IReceiveReferralService;
import pc.entity.ReferralInfoDTO;

public class ReceiveReferralServiceImpl extends Overall_Receive_Referral implements IReceiveReferralService{

	private IReceiveReferralDao receiveReferralDao;

	

	public ReferralInfoDTO findReferralInfoById(Long id) {
		return (ReferralInfoDTO) receiveReferralDao.findById(id);
	}

	public ReferralInfoDTO findReferralInfoByInstanceId(Long instanceId) {
		List<PersistantCapableDTO> infoList = receiveReferralDao.findByInstanceId(instanceId);
		if(infoList == null || infoList.size() == 0)
			return null;
		return (ReferralInfoDTO) infoList.get(0);
	}
	

	public ReferralInfoDTO saveReferralInfo(ReferralInfoDTO referralInfo) throws IlligalOperationException {
		receiveReferralDao.saveEntity(referralInfo);
		action(referralInfo.getInstanceId());
		return referralInfo;
	}



	public ReferralInfoDTO updateReferralInfo(ReferralInfoDTO referralInfo) {
		receiveReferralDao.updateEntity(referralInfo);
		return referralInfo;
	}
	
	
	public void setReceiveReferralDao(IReceiveReferralDao receiveReferralDao) {
		this.receiveReferralDao = receiveReferralDao;
	}
	
	public boolean isManual()
	{
		return true;
	}
}
