package pc.TeamBuilding.service;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import ca.stfx.logic.cwf.engine.base.AbstractTask;
import ca.stfx.logic.cwf.engine.base.entity.InstanceInfo;
import ca.stfx.logic.cwf.engine.exception.IlligalOperationException;
import pc.util.Constants;
import ca.stfx.logic.cwf.engine.base.ActionInterface;
import ca.stfx.logic.cwf.engine.base.IBranchCondition;
import ca.stfx.logic.cwf.engine.base.AbortInterface;

abstract public class TeamBuilding_Patient_Location extends AbstractTask implements ActionInterface, IBranchCondition, AbortInterface{

	public final List<String> getAvailableOperations(long instanceId, Map<String, InstanceInfo> varMap){
		List<String> ops = new ArrayList<String>();

		if ( (varMap.get(Constants._TeamBuilding_Assign_Caregivers_OK) != null && varMap.get(Constants._TeamBuilding_Assign_Caregivers_OK).getValue()  > 0 ) & (varMap.get(Constants._TeamBuilding_Assign_Caregivers_SUC_0) != null && varMap.get(Constants._TeamBuilding_Assign_Caregivers_SUC_0).getValue()  > 0 ) )
				ops.add( _ACTION );
		if ( ((varMap.get(Constants._TeamBuilding_Assign_Caregivers_OK) != null && varMap.get(Constants._TeamBuilding_Assign_Caregivers_OK).getValue()  == 0 ))  & (varMap.get(Constants._TeamBuilding_Assign_Caregivers_SUC_0) != null && varMap.get(Constants._TeamBuilding_Assign_Caregivers_SUC_0).getValue()  > 0) )
				ops.add( _ABORT );
		if ( (varMap.get(Constants._TeamBuilding_Home_Service_ABT) != null && varMap.get(Constants._TeamBuilding_Home_Service_ABT).getValue()  > 0 )| (varMap.get(Constants._TeamBuilding_Informal_Caregiver_ABT) != null && varMap.get(Constants._TeamBuilding_Informal_Caregiver_ABT).getValue()  > 0 ) )
				ops.add( _ABORT );
		return ops;
	}
	public void action(long instanceId)throws IlligalOperationException{
		Map<String, InstanceInfo> varMap = workflowEngineService.getVarMap(instanceId);

		if ( (varMap.get(Constants._TeamBuilding_Assign_Caregivers_OK) != null && varMap.get(Constants._TeamBuilding_Assign_Caregivers_OK).getValue()  > 0 ) & (varMap.get(Constants._TeamBuilding_Assign_Caregivers_SUC_0) != null && varMap.get(Constants._TeamBuilding_Assign_Caregivers_SUC_0).getValue()  > 0 ) ){			
			decrValue(varMap, Constants._TeamBuilding_Assign_Caregivers_SUC_0);
		}
		if ( (varMap.get(Constants._TeamBuilding_Assign_Caregivers_OK) != null && varMap.get(Constants._TeamBuilding_Assign_Caregivers_OK).getValue()  > 0 ) & getBranchCondition(instanceId, 1) ){			
			incrValue(varMap, Constants._TeamBuilding_Patient_Location_SUC_0);
			workflowEngineService.updateTaskStatus(instanceId, varMap);
			return;
		}
		if ( (varMap.get(Constants._TeamBuilding_Assign_Caregivers_OK) != null && varMap.get(Constants._TeamBuilding_Assign_Caregivers_OK).getValue()  > 0 ) & getBranchCondition(instanceId, 2) ){			
			incrValue(varMap, Constants._TeamBuilding_Patient_Location_SUC_1);
			workflowEngineService.updateTaskStatus(instanceId, varMap);
			return;
		}
			throw new IlligalOperationException("Error executing workflow. Operation action is not allowed right now.");
	}
	public void abort(long instanceId)throws IlligalOperationException{
		Map<String, InstanceInfo> varMap = workflowEngineService.getVarMap(instanceId);

		if ( ((varMap.get(Constants._TeamBuilding_Assign_Caregivers_OK) != null && varMap.get(Constants._TeamBuilding_Assign_Caregivers_OK).getValue()  == 0 ))  & (varMap.get(Constants._TeamBuilding_Assign_Caregivers_SUC_0) != null && varMap.get(Constants._TeamBuilding_Assign_Caregivers_SUC_0).getValue()  > 0) ){			
			decrValue(varMap, Constants._TeamBuilding_Assign_Caregivers_SUC_0);
			incrValue(varMap, Constants._TeamBuilding_Patient_Location_ABT);
			workflowEngineService.updateTaskStatus(instanceId, varMap);
			return;
		}
		if ( (varMap.get(Constants._TeamBuilding_Home_Service_ABT) != null && varMap.get(Constants._TeamBuilding_Home_Service_ABT).getValue()  > 0 )| (varMap.get(Constants._TeamBuilding_Informal_Caregiver_ABT) != null && varMap.get(Constants._TeamBuilding_Informal_Caregiver_ABT).getValue()  > 0 ) ){			
			incrValue(varMap, Constants._TeamBuilding_Patient_Location_ABT);
		}
		if ( (varMap.get(Constants._TeamBuilding_Home_Service_ABT) != null && varMap.get(Constants._TeamBuilding_Home_Service_ABT).getValue()  > 0) ){			
			decrValue(varMap, Constants._TeamBuilding_Home_Service_ABT);
			workflowEngineService.updateTaskStatus(instanceId, varMap);
			return;
		}
		if ( (varMap.get(Constants._TeamBuilding_Informal_Caregiver_ABT) != null && varMap.get(Constants._TeamBuilding_Informal_Caregiver_ABT).getValue()  > 0) ){			
			decrValue(varMap, Constants._TeamBuilding_Informal_Caregiver_ABT);
			workflowEngineService.updateTaskStatus(instanceId, varMap);
			return;
		}
			throw new IlligalOperationException("Error executing workflow. Operation abort is not allowed right now.");
	}

	public String getTaskName(){
		return "TeamBuilding_Patient_Location";
	}
}
