package pc.TeamBuilding.service;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import ca.stfx.logic.cwf.engine.base.AbstractTask;
import ca.stfx.logic.cwf.engine.base.entity.InstanceInfo;
import ca.stfx.logic.cwf.engine.exception.IlligalOperationException;
import pc.util.Constants;
import ca.stfx.logic.cwf.engine.base.ActionInterface;
import ca.stfx.logic.cwf.engine.base.AbortInterface;

public class TeamBuilding_Start extends AbstractTask implements ActionInterface, AbortInterface{

	public final List<String> getAvailableOperations(long instanceId, Map<String, InstanceInfo> varMap){
		List<String> ops = new ArrayList<String>();

		if ( (varMap.get(Constants._Overall_Team_Building_CStart) != null && varMap.get(Constants._Overall_Team_Building_CStart).getValue()  > 0) )
				ops.add( _ACTION );
		if ( (varMap.get(Constants._TeamBuilding_Assign_Caregivers_ABT) != null && varMap.get(Constants._TeamBuilding_Assign_Caregivers_ABT).getValue()  > 0) )
				ops.add( _ABORT );
		return ops;
	}
	public void action(long instanceId)throws IlligalOperationException{
		Map<String, InstanceInfo> varMap = workflowEngineService.getVarMap(instanceId);

		if ( (varMap.get(Constants._Overall_Team_Building_CStart) != null && varMap.get(Constants._Overall_Team_Building_CStart).getValue()  > 0) ){			
			decrValue(varMap, Constants._Overall_Team_Building_CStart);
			incrValue(varMap, Constants._TeamBuilding_Start_SUC);
			workflowEngineService.updateTaskStatus(instanceId, varMap);
			return;
		}
			throw new IlligalOperationException("Error executing workflow. Operation action is not allowed right now.");
	}
	public void abort(long instanceId)throws IlligalOperationException{
		Map<String, InstanceInfo> varMap = workflowEngineService.getVarMap(instanceId);

		if ( (varMap.get(Constants._TeamBuilding_Assign_Caregivers_ABT) != null && varMap.get(Constants._TeamBuilding_Assign_Caregivers_ABT).getValue()  > 0) ){			
			decrValue(varMap, Constants._TeamBuilding_Assign_Caregivers_ABT);
			incrValue(varMap, Constants._Overall_Team_Building_CAbtEnd);
			workflowEngineService.updateTaskStatus(instanceId, varMap);
			return;
		}
			throw new IlligalOperationException("Error executing workflow. Operation abort is not allowed right now.");
	}

	public String getTaskName(){
		return "TeamBuilding_Start";
	}
}
