package pc.TeamBuilding.service.impl;

import java.util.List;


import ca.stfx.logic.cwf.engine.base.entity.PersistantCapableDTO;
import ca.stfx.logic.cwf.engine.exception.IlligalOperationException;


import pc.Overall.dao.IHomeServiceDao;
import pc.Overall.service.interfaces.IPatientRegistrationService;
import pc.TeamBuilding.service.TeamBuilding_Find_HomeService;
import pc.TeamBuilding.service.interfaces.IHomeService;
import pc.entity.HomeServiceDTO;
import pc.entity.PatientDTO;


public class HomeServiceImpl extends TeamBuilding_Find_HomeService  implements IHomeService{

	private IHomeServiceDao homeServiceDao;
	private IPatientRegistrationService patientRegistrationService;

	

	public HomeServiceDTO findHomeServiceInfoById(Long id) {
		return (HomeServiceDTO) homeServiceDao.findById(id);
	}

	

	public HomeServiceDTO saveHomeService(HomeServiceDTO homeServiceInfo)
	throws IlligalOperationException {
		homeServiceDao.saveEntity(homeServiceInfo);		
		return homeServiceInfo;
	}



	public HomeServiceDTO updateHomeServiceInfo(HomeServiceDTO homeServiceInfo) {
		homeServiceDao.updateEntity(homeServiceInfo);
		return homeServiceInfo;
	}
	
	
	public void setHomeServiceDao(IHomeServiceDao homeServiceDao) {
		this.homeServiceDao = homeServiceDao;
	}

	public List<PersistantCapableDTO> findAllHomeService() {
		return  homeServiceDao.findAllEntity();		
	}



	public List<HomeServiceDTO> findHomeServiceByZipCode(String zipCode) {
		return homeServiceDao.findHomeServiceByZipCode(zipCode);		
	}



	public void allocateHomeServiceToPatient(PatientDTO thePatient,
			HomeServiceDTO homeServiceDTO) throws IlligalOperationException {
		thePatient.setHomeServiceId(homeServiceDTO.getId());
		patientRegistrationService.updatePatientInfo(thePatient);
		action(thePatient.getInstanceId());		
	}



	public void setPatientRegistrationService(
			IPatientRegistrationService patientRegistrationService) {
		this.patientRegistrationService = patientRegistrationService;
	}
		
	public boolean isManual()
	{
		return true;
	}
}
