package pc.TeamBuilding.service.impl;

import java.util.List;


import ca.stfx.logic.cwf.engine.base.entity.PersistantCapableDTO;
import ca.stfx.logic.cwf.engine.exception.IlligalOperationException;

import pc.Overall.dao.IInformalCaregiverDao;

import pc.TeamBuilding.service.TeamBuilding_Informal_Caregiver2;
import pc.TeamBuilding.service.interfaces.IInformalCaregiverService;
import pc.entity.InformalCaregiverInfoDTO;



public class InformalCaregiver2ServiceImpl extends TeamBuilding_Informal_Caregiver2 implements IInformalCaregiverService{

	private IInformalCaregiverDao informalCaregiverDao;

	

	public InformalCaregiverInfoDTO findInformalCaregiverInfoById(Long id) {
		return (InformalCaregiverInfoDTO) informalCaregiverDao.findById(id);
	}

	public InformalCaregiverInfoDTO findInformalCaregiverInfoByInstanceId(Long instanceId) {
		List<PersistantCapableDTO> infoList = informalCaregiverDao.findByInstanceId(instanceId);
		if(infoList == null || infoList.size() == 0)
			return null;
		return (InformalCaregiverInfoDTO) infoList.get(0);
	}
	

	public InformalCaregiverInfoDTO saveInformalCaregiverInfo(InformalCaregiverInfoDTO informalCaregiverInfo) throws IlligalOperationException {
		informalCaregiverDao.saveEntity(informalCaregiverInfo);
		action(informalCaregiverInfo.getInstanceId());
		return informalCaregiverInfo;
	}



	public InformalCaregiverInfoDTO updateInformalCaregiverInfo(InformalCaregiverInfoDTO informalCaregiverInfo) {
		informalCaregiverDao.updateEntity(informalCaregiverInfo);
		return informalCaregiverInfo;
	}
	
	
	
	public boolean isManual()
	{
		return true;
	}

	public void setInformalCaregiverDao(IInformalCaregiverDao informalCaregiverDao) {
		this.informalCaregiverDao = informalCaregiverDao;
	}
}
